;
;		RESTRICTED RIGHTS LEGEND
;		------------------------
;	
;	    "Use, duplication, or disclosure by the
;	Government is subject to restrictions as set forth
;	in paragraph (b) (3) (B) of the Rights in Technical
;	Data and Computer Software clause in DAR
;	7-104.9(a).  Contractor/manufacturer is Zenith
;	Data Systems Corporation of Hilltop Road, St.
;	Joseph, Michigan 49085.
;
;
; Definitions for 8253 programmable interval timer
;

;  PORT DISPLACEMENTS

PITC0	EQU	000H		;COUNTER 0
PITC1	EQU	001H		;COUNTER 1
PITC2	EQU	002H		;COUNTER 2
PITCW	EQU	003H		;CONTROL WORD

;  CONTROL WORD

PITSC	EQU	11000000B	;SELECT COUNTER
PITSC0	EQU	000H		; 0
PITSC1	EQU	040H		; 1
PITSC2	EQU	080H		; 2

PITRL	EQU	00110000B	;READ/LOAD
PITRLCL	EQU	000H		; COUNTER LATCHING OPERATION
PITRLMB	EQU	010H		; MSB
PITRLLB	EQU	020H		; LSB
PITRLW	EQU	030H		; WORD

PITM	EQU	00001110B	;MODE
PITMITC	EQU	000H		; 0 - INTERRUPT ON TERMINAL COUNT
PITMP1S	EQU	002H		; 1 - PROGRAMMABLE ONE SHOT
PITMRG	EQU	004H		; 2 - RATE GENERATOR
PITMSW	EQU	006H		; 3 - SQUARE WAVE RATE GENERATOR
PITMSTS	EQU	008H		; 4 - SOFTWARE TRIGGERED STROBE
PITMHTS	EQU	00AH		; 5 - HARDWARE TRIGGERED STROBE

PITBCD	EQU	00000001B	;0 = 16 BIT BINARY COUNTER
				;1 = 4 DIGIT BCD COUNTER
